<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<!--
 ! $Source: /cvsstl/ti/pa/sio/dcs6/dcs6_tp.html,v $
 ! $Revision: 1.9 $
 !
 ! DCS6 Transport Protocol documentation
 !
 ! Copyright 2009, Texas Instruments India. All rights reserved.
 !
 ! $Log: dcs6_tp.html,v $
 ! Revision 1.9  2009/09/04 13:08:03  ghavaldar
 ! Minor modifications and typo's (MID #1758)
 !
 ! Revision 1.8  2009/09/04 05:12:25  ghavaldar
 ! Added sample code to demonstrate conversion between alpha codes and
 ! S-records (MID #1758)
 !
 ! Revision 1.7  2009/09/03 10:07:14  ghavaldar
 ! Added implementation specific details on the UART response (MID #1758)
 !
 ! Revision 1.6  2009/09/03 08:47:55  ghavaldar
 ! Added information of ascii communication (MID #1758)
 !
 ! Revision 1.5  2009/09/01 04:59:23  ghavaldar
 ! Added SPI 16-bit communication details (MID #1758)
 !
 ! Revision 1.4  2009/08/31 08:26:21  ghavaldar
 ! Organized the content and added TOC (MID #1758)
 !
 ! Revision 1.3  2009/08/31 06:25:51  ghavaldar
 ! Improved details and formatting (MID #1758)
 !
 ! Revision 1.2  2009/08/28 10:23:01  ghavaldar
 ! Added SPI 8-bit communication transport protocol description (MID #1758)
 !
 ! Revision 1.1  2009/08/27 04:51:02  ghavaldar
 ! Initial version of DCS6 Transport Protocol documentation. Contains I2C
 ! transport protocol documentation (MID #1758)
 !
 -->
  <meta content="text/html; charset=ISO-8859-1"
 http-equiv="content-type">
  <title>DCS6 Transport Protocol</title>
</head>
<body style="background-color: rgb(192, 192, 192); color: rgb(0, 0, 0);"
 alink="#ee0000" link="#0000ee" vlink="#551a8b">
<h2 style="text-align: center;"><a class="mozTocH2"
 name="mozTocId587679"></a>DCS6
Transport Protocol</h2>
<!--mozToc h3 1 h4 2 h5 3-->
<ul id="mozToc">
<!--mozToc h3 1 h4 2 h5 3--><li><a href="#mozTocId624983">Introduction</a></li>
  <li><a href="#mozTocId499477">Binary
Communication Mode</a>
    <ul>
      <li><a href="#mozTocId259917">Serial
Link Control</a></li>
      <li><a href="#mozTocId491250">I2C
Communication</a></li>
      <li><a href="#mozTocId71002">SPI
Communication</a>
        <ul>
          <li><a href="#mozTocId937562">SPI
8-bit Communication</a></li>
          <li><a href="#mozTocId545221">SPI
16-bit
Communication</a></li>
        </ul>
      </li>
    </ul>
  </li>
  <li><a href="#mozTocId940449">Ascii
Communication
Mode</a>
    <ul>
      <li><a href="#mozTocId790173">S-Records</a></li>
      <li><a href="#mozTocId690164">UART
Communication</a></li>
    </ul>
  </li>
  <li><a href="#mozTocId24536">References</a></li>
</ul>
<h3><a class="mozTocH3" name="mozTocId624983"></a><a id="Intro"
 name="Introduction"></a>Introduction</h3>
The DCS6 module provides the ability to control the behavior of the
DA8xx PA software and obtain status information. The application
protocol used for communication is described in the <cite>Performance
Audio Messaging Application Protocol Application Report<a
 href="#References"><sup>[1]</sup></a>
</cite>and
the
complete list of commands can be found in the PA software
release. This document describes the transport protocol used by the
DCS6 module. The DCS6&nbsp; transport protocol is discussed at
length in the <cite>Performance
Audio
Messaging Transport Protocol Application Report<a href="#References"><sup>[2]</sup></a></cite>
along with the transport protocols that have been
used in PA software prior to DCS6 module and then some that are defined
but not yet
implemented. For most of the users of the DCS6 module this document
should provide all the required information and is expected to be
sufficient for achieving control/status of the PA software and the <cite>Performance
Audio Messaging Transport Protocol Application Report</cite><cite><a
 href="dcs6_tp.html#References"><sup>[2]</sup></a></cite><cite>
</cite>can
be
used for reference occasionally.<br>
<br>
The DCS6 module supports communication using binary representation of
the data with the SPI and I2C devices and ascii representation of the
data with the UART device. Regardless of the data representation the
commands and messages are constructed as per the application protocol
described in <cite>Performance
Audio Messaging Application Protocol Application Report</cite><cite><a
 href="dcs6_tp.html#References"><sup>[1]</sup></a></cite><cite>.
</cite>The
transport protocols used for different modes of communication and for
each of the devices are described in detail in the following sections.<br>
<br>
<hr style="width: 100%; height: 2px;">
<h3><a class="mozTocH3" name="mozTocId499477"></a><a id="BCM"
 name="Binary_Communication_Mode"></a>Binary
Communication Mode</h3>
The DCS6 module supports communication over the SPI and I2C devices
using binary mode of communication. The DCS6 module supports I2C
communication with element size of 1 byte (8 bits) and SPI
communication with element sizes of 1 byte (8 bits) and 2 bytes (16
bits). The I2C device uses the clock hold mechanism for flow control
while the SPI device supports different modes, some using the SPI
native&nbsp; flow control while others with no flow control
mechanism. These
differences demand a different transport protocol to be used for the
two
devices. This does not necessarily mean that the communication is
entirely different for the two devices. The application protocol
governing the design and construction of the commands and messages is
same as described in <cite>Performance
Audio Messaging Application Protocol Application Report</cite><cite><a
 href="dcs6_tp.html#References"><sup>[1]</sup></a></cite><cite>.&nbsp;</cite>
The queries and responses to check the underlying link are also same as
described in <a href="#Serial_Link_Control">Serial
Link Control</a>. The alpha
commands/messages and SLC commands/SLS messages are exchanged between
the master and slave in little endian format i.e. the least significant
byte is transmitted before and the most significant byte in a word and
least significant word is transmitted before the most significant word
in a multi-word command/message.
<h4><a class="mozTocH4" name="mozTocId259917"></a><a id="SLC"
 name="Serial_Link_Control"></a>Serial
Link Control</h4>
The DCS6 module supports certain commands and messages that address the
underlying link mechanism. These are different from the application
commands and messages or alpha commands. The DCS6 module supports the
following Serial Link Control (SLC) commands to control the underlying
link:<br>
<ul>
  <li><strong>Reset
- </strong>The Reset SLC command
"0x8001" can be used by the microcontroller/master to reset the
physical link used by the DCS6 module. The response is Success SLS
message "0xF001" for success and Error SLS message "0xF101" for error
state.<br>
  </li>
  <li><strong>Ready
- </strong>The Ready SLC command
"0x8101" can be used by the microcontroller/master to check if the DCS6
module is ready for communication. The response is Success SLS message
"0xF001" for success and Error SLS message "0xF101" for error state.</li>
</ul>
The DCS6 module supports the following Serial Link Status (SLS)
messages. The SLS messages are sent by the DCS6 module in response to
the SLC commands sent by the microcontroller/master.<br>
<ul>
  <li><strong>Success
- </strong>The Success SLS message
"0xF001" indicates that the operation requested by the SLC command is
successful.</li>
  <li><strong>Error
- </strong>The Error SLS message
"0xF101" indicates that the operation requested by the SLC command has
met with some problems and cannot be completed.</li>
</ul>
<h4><a class="mozTocH4" name="mozTocId491250"></a><a id="I2CC"
 name="I2C_Communication"></a>I2C
Communication</h4>
The DCS6 module supports binary communication using the DA8xx I2C0 and
I2C1 devices. The I2C devices supports communication with element size
of 1 byte (8 bits). The I2C communication requires the payload (a
payload may have one or more application commands/messages or alpha
commands/messages) to be encapsulated using a Count field. The
Count field is 1
byte in length if the payload length does not exceed 254 bytes and
indicates the number of elements following the Count field. Since alpha
commands are defined in units and multiples of 16 bits the Count field
value in this case is always even. For payloads larger than 254 bytes
the Count field is 2 bytes in length and its value also includes the
second byte of the Count field. Thus the Count field value is always
odd in this
case. The Count field can have values in the range of 0x0001-0x7FFF.
The 0x8000-0xFFFF range of values is reserved for the purpose of SLC
commands and SLS messages as described in <a
 href="dcs6_tp.html#Serial_Link_Control">Serial Link
Control</a>. The different range of
values helps in distinguishing between the application
commands/messages and link control commands/messages. The Count field
makes the payload exchange simpler and avoids any payload parsing and
interpretation at the device level.&nbsp; A little endian
representation of data is assumed i.e. the least significant byte is
transmitted prior to most significant byte in a 16 bit word and least
significant word is transmitted prior to most significant word in a
multi-word transaction.<br>
<h6><a class="mozTocH6" name="mozTocId980709"></a>Examples</h6>
<span style="font-family: monospace;">Consider
a payload of the form:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0xpqrs,0xtuvw<br>
</code></div>
<br style="font-family: monospace;">
<span style="font-family: monospace;">The
payload is specified in the
hexadecimal format with p,q,r,s and
t,u,v,w representing the nibbles (4 bits) in the 16-bit words. Since
the payload consists of 4 elements (bytes) the Count field value is 4.
With little endian format used for transmission the data on the I2C bus
in element size units would look like:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x04,0xrs,0xpq,0xvw,0xtu<br>
<br>
</code></div>
<span style="font-family: monospace;">If
this command generates a
response </span><code style="font-family: monospace;">0xwxyz
</code><span style="font-family: monospace;">where
w,x,y,z represent the nibbles (4 bits) in the 16-bit response then the
message is transmitted back in little endian format like:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x02,0xyz,0xwx</code><br>
</div>
<br style="font-family: monospace;">
<span style="font-family: monospace;">Now
consider the same payload
above needs to be transmitted 75 times in
a
single session. Though transmitting the same payload multiple times in
a session does not make any practical sense, it is used here to
demonstrate a payload transmission with a 2 byte Count field. The total
length of the payload in this case would be 300 elements (75*4 bytes).
With little endian format used for transmission the data on the I2C bus
in element size units would look like:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x2D,0x01,</code><code>0xrs,0xpq,0xvw,0xtu,</code><code>0xrs,0xpq,0xvw,0xtu,..........,</code><code>0xrs,0xpq,0xvw,0xtu<br>
<br>
</code></div>
<span style="font-family: monospace;">The
Ready SLC command sent over
the I2C bus in little endian format
would appear like:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x01,0x80<br>
<br>
</code></div>
<span style="font-family: monospace;">and
the Success SLS received
would appear like:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x01,0xF0<br>
<br>
</code></div>
<span style="font-family: monospace;">The
examples above just represent
the payload data and the I2C specific
Start, Address, Acknowledge and Stop bits are not shown here. This is
done deliberately to emphasize the I2C communication payload
construction. For details on the I2C physical protocol refer the DA8xx
User Guide. The I2C slave address used by the DCS6 module is
configurable. For more details on this refer the documentation on <cite>DCS6
parameters</cite></span><cite style="font-family: monospace;"><a
 href="dcs6_tp.html#References"><sup>[3]</sup></a></cite><span
 style="font-family: monospace;">.</span><br>
<br>
The DCS6 module does not source any messages by itself, but only
responds to the commands sent by the microcontroller/master. The
SLC commands sent by the master result in the generation of SLS
messages and the alpha command payloads sent by the master may invoke a
response message payload depending upon the constituent alpha commands.
<br>
<br>
The DCS6 module I2C communication uses the I2C clock hold mechanism to
prevent a fast microcontroller/master from overrunning the slave. The
flow control mechanism is exercised depending upon the receive buffer
levels and hence the DCS6 I2C slave may hold the clock low in the
middle of a payload transaction.<br>
<br>
The DCS6 module can be configured to detect and report certain error
conditions with the I2C communication. The mechanism to report the
error conditions can be configured with the DCS6 module API's that
allow initialization, assertion and de-assertion of the selected
mechanism. For more on this
refer the <cite>DCS6 Parameters<a href="#References"><sup>[3]</sup></a></cite>
documentation.<br>
<h4><a class="mozTocH4" name="mozTocId71002"></a><a id="SPIC"
 name="SPI_Communication"></a>SPI
Communication</h4>
The DCS6 module supports binary communication using the DA8xx SPI0 and
SPI1 devices. The DA8xx SPI device supports communication with element
size of 1 byte (8 bits) and 2 bytes (16 bits). The transport protocols
used for the two modes are described in the following sections.<br>
<h5><a class="mozTocH5" name="mozTocId937562"></a><a id="SPI8C"
 name="SPI_8-bit_Communication"></a>SPI
8-bit Communication</h5>
The SPI slave device does not have a specific slave address which it
can acknowledge when the master attempts to establish communication.
Hence establishing a proper communication channel between the master
and slave requires a proper handshake mechanism. The DCS6 SPI slave
device requires the master to stream zero (0x00) data on the SPISIMO
pin continuously until the slave is ready. If the slave is ready to
communicate then the slave
will transmit 0xF101 on the SPISOMI pin, otherwise the data on the
SPISOMI pin should be 0x00. Once the slave has communicated its
readiness, the master can then send commands to the slave as described
in the rest of the section. The link establishment process between the
master
and slave on the SPI data lines should look like:<br>
<br>
<div style="margin-left: 200px;"><code>Data
on SPISIMO pin: 0x00,0x00,..........,0x00,0x00,0x00,Command<br>
Data on SPISOMI pin: 0x00,0x00,..........,0x00,0x01,0xF1<br>
<br>
</code></div>
where "Command" represents any application command or link control
command. Note that the communication uses little endian mode of data
transfer i.e. the least significant byte is transmitted prior to the
most significant byte in a 16-bit word.<br>
<br>
Once the communication channel is established the sending of the
commands by the master and generated responses by the slave is similar
to the <a href="#I2C_Communication">I2C
Communication</a> but not exactly
identical. A payload (a
payload may have one or more application commands and messages or alpha
commands and messages) needs to be encapsulated using a Count field.
The Count field
is 1
byte in length if the payload length does not exceed 254 bytes and
it&nbsp; indicates the number of elements following the Count field.
Since alpha
commands are defined in units and multiples of 16 bits, the Count field
value in this case is always even. For payloads larger than 254 bytes
the Count field is 2 bytes in length and its value also includes the
second byte of the Count field. Thus the Count field value is always
odd in this
case. The Count field can have values in the range of 0x0001-0x7FFF.
The 0x8000-0xFFFF range of values is reserved for the purpose of SLC
commands and messages as described in <a
 href="dcs6_tp.html#Serial_Link_Control">Serial Link
Control</a>. The different range of
values helps in distinguishing between the application
commands/messages and link control commands/messages. The Count field
makes the payload exchange simpler and avoids any payload parsing and
interpretation at the device level.&nbsp; A little endian
representation of data is assumed i.e. the least significant byte is
transmitted prior to most significant byte in a 16 bit word and least
significant word is transmitted prior to most significant word in a
multi-word transaction. This method of transfer is used for both
command payloads and response message payloads. <br>
<br>
The SPI data transfers are always initiated by the SPI master by
generating clock signal on the SPICLK pin and sending the command
payload on the SPISIMO pin.&nbsp; If the DCS6 SPI slave has no data
to
send back during this time, it sends zero (0x00) data on the
SPISOMI pin. After sending a command
payload that generates a response the SPI master has no means to know
when the DCS6 SPI slave would be ready with the response message. Since
the data transfers are always initiated by the SPI master, the SPI
master&nbsp; is
required to
stream zero (0x00) data on the SPISIMO pin until the SPI slave outputs
the response message on the SPISOMI pin. Also while the DCS6 SPI slave
is busy
processing the received command and generating a response it still
needs to respond to the zero (0x00) data streamed by the SPI master on
the
SPISIMO pin and it does so by transmitting zero's (0x00) on the SPISOMI
pin. Once the command payload is processed by the DCS6 SPI slave it
starts transmitting the generated response. The SPI master should
stream zero's (0x00) on the SPISIMO pin until it receives the complete
response from the slave. This method of streaming zero's is applicable
only when the command payload (i.e.both
application command payloads and link control command payloads)
generates a response. For
application command payloads that do not generate a response, the SPI
master need not stream zero's and can send the next command payload
immediately depending upon the SPI flow control mechanism used and its
indicated status. The zero (0x00) data streaming used by the SPI master
and slave should always happen at payload boundaries i.e. a zero (0x00)
data fill should never be done in the middle of a payload transfer
unless the payload data itself contains an element with zero value.<br>
<h6><a class="mozTocH6" name="mozTocId161523"></a>Examples</h6>
<span style="font-family: monospace;">Consider
a payload of the form:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0xpqrs,0xtuvw<br>
</code></div>
<br style="font-family: monospace;">
<span style="font-family: monospace;">The
payload is specified in the
hexadecimal format with p,q,r,s and
t,u,v,w representing the nibbles (4 bits) in the 16-bit words. Since
the payload consists of 4 elements (bytes) the Count field value is 4.
With little endian format used for transmission the data on the SPISIMO
pin in element size units would look like:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x04,0xrs,0xpq,0xvw,0xtu<br>
<br>
</code></div>
<span style="font-family: monospace;">If
this command generates a
response </span><code style="font-family: monospace;">0xwxyz
</code><span style="font-family: monospace;">where
w,x,y,z represent the nibbles (4 bits) in the 16-bit response then the
message is transmitted back on the SPISOMI pin in little endian format
like:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x02,0xyz,0xwx<br>
<br>
</code></div>
<span style="font-family: monospace;">Applying
the zero fill between
the command and response the data on the
SPI data lines should be of the form:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>Data
on SPISIMO pin: </code><code>0x04,0xrs,0xpq,0xvw,0xtu,</code><code>0x00,..........,0x00,0x00,0x00,0x00<br>
Data on SPISOMI pin: 0x00,...................................,0x00,</code><code>0x02,0xyz,0xwx<br>
<br>
</code></div>
<span style="font-family: monospace;">Now
consider the same payload
above needs to be transmitted 75 times in
a
single session. Though transmitting the same payload multiple times in
a session does not make any practical sense, it is used here to
demonstrate a payload transmission with a 2 byte Count field. The total
length of the payload in this case would be 300 elements (75*4 bytes).
With little endian format used for transmission the data on the SPI
data lines in element size units would look like:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(0)
on SPISIMO pin: </code><code>0x2D,0x01,</code><code>0xrs,0xpq,0xvw,0xtu,</code><code>0xrs,0xpq,0xvw,0xtu,......</code><code></code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(0)
on SPISOMI pin:
0x00,...................................................</code><code></code><br>
</div>
<code></code></div>
<code style="font-family: monospace;"></code><br
 style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(1)
on SPISIMO pin:</code><code>
.....,</code><code>0xrs,0xpq,0xvw,0xtu</code><code>,</code><code>0x00,.........................</code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(1)
on SPISOMI pin:
0x00,...................................................</code><code></code><br>
</div>
<code></code></div>
<code style="font-family: monospace;">
</code><br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(2)
on SPISIMO pin:</code><code>
.....,</code><code>0x</code><code>00,............................,0x00,0x00</code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(2)
on SPISOMI pin:
.....,0x96,</code><code>0xyz,0xwx,</code><code>0xyz,0xwx,</code><code>........,0xyz,0xwx</code><br>
</div>
<code></code></div>
<code style="font-family: monospace;">
</code><br style="font-family: monospace;">
<code style="font-family: monospace;"></code><span
 style="font-family: monospace;">In
the case of command payloads that do not generate a
response the zero data fill is not required and the commands can be
sent back to back in the form:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISIMO pin: </code><code>0x02,0xij,0xgh,</code><code>0x02,0xij,0xgh</code><code></code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISOMI pin:
0x00,...................,0x00<br>
</code><code></code><br>
</div>
<code></code></div>
<span style="font-family: monospace;">where
g,h,i,j represent the
nibbles (4 bits) in the 16-bit command
payload that does not generate a response.</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<span style="font-family: monospace;">The
Ready SLC command sent over
the SPISIMO pin and the corresponding
Success SLS response sent over the SPISOMI pin in little endian format
would appear like:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISIMO pin: </code><code>0x01,0x80,</code><code>0x00,..........,0x00,0x00</code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISOMI pin:
0x00,....................,0x01,</code><code>0xF0<br>
<br>
</code></div>
<code></code></div>
<code style="font-family: monospace;"></code><span
 style="font-family: monospace;">
The examples above just represent the payload data and the complete SPI
transfer protocol with all signals is not shown here. This is
done deliberately to emphasize the SPI communication payload
construction and transmission. In addition to the little endian mode of
data transfer it is important to note here that within a byte the most
significant bit is shifted out on the SPI data pin prior to the least
significant bit. For details on the SPI physical protocol
refer the DA8xx
SPI User Guide.</span><br>
<h5><a class="mozTocH5" name="mozTocId545221"></a><a id="SPI16C"
 name="SPI_16-bit_Communication"></a>SPI
16-bit
Communication</h5>
The SPI slave device does not have a specific slave address which it
can acknowledge when the master attempts to establish communication.
Hence establishing a proper communication channel between the master
and slave requires a proper handshake mechanism. The DCS6 SPI slave
device requires the master to stream zero (0x0000) data on the SPISIMO
pin continuously until the slave is ready. If the slave is ready to
communicate then the slave
will transmit 0xF101 on the SPISOMI pin, otherwise the data on the
SPISOMI pin should be 0x0000. Once the slave has communicated its
readiness, the master can then send commands to the slave as described
in the rest of the section. The link establishment process between the
master
and slave on the SPI data lines should look like:<br>
<br>
<div style="margin-left: 200px;"><code>Data
on SPISIMO pin: 0x0000,0x0000,..........,0x00,0x0000,Command<br>
Data on SPISOMI pin: 0x0000,0x0000,..........,0x00,0xF101<br>
<br>
</code></div>
where "Command" represents any application command or link control
command.<br>
<br>
Once the communication channel is established the sending of the
commands by the master and generated responses by the slave is similar
to the <a href="#SPI_8-bit_Communication">SPI
8-bit
Communication</a>, the differences
arising primarily due to the change
in the element size. A payload (a
payload may have one or more application commands and messages or alpha
commands and messages) needs to be encapsulated using a Count field.
The Count field is always 2 bytes (1 element size word) in length and
indicates the number of elements following the Count field. The Count
field can have values in the range of 0x0001-0x7FFF.
The 0x8000-0xFFFF range of values is reserved for the purpose of SLC
commands and messages as described in <a
 href="dcs6_tp.html#Serial_Link_Control">Serial Link
Control</a>. The different range of
values helps in distinguishing between the application
commands/messages and link control commands/messages. The Count field
makes the payload exchange simpler and avoids any payload parsing and
interpretation at the device level. A little endian
representation of data is assumed i.e. the least
significant word is transmitted prior to most significant word in a
multi-word transaction. This method of transfer is used for both
command payloads and response message payloads. <br>
<br>
The SPI data transfers are always initiated by the SPI master by
generating clock signal on the SPICLK pin and sending the command
payload on the SPISIMO pin.&nbsp; If the DCS6 SPI slave has no data
to
send back during this time, it sends zero (0x0000) data on the
SPISOMI pin. After sending a command
payload that generates a response the SPI master has no means to know
when the DCS6 SPI slave would be ready with the response message. Since
the data transfers are always initiated by the SPI master, the SPI
master is
required to
stream zero (0x0000) data on the SPISIMO pin until the SPI slave
outputs
the response message on the SPISOMI pin. Also while the DCS6 SPI slave
is busy
processing the received command and generating a response it still
needs to respond to the zero (0x0000) data streamed by the SPI master
on
the
SPISIMO pin and it does so by transmitting zero's (0x0000) on the
SPISOMI
pin. Once the command payload is processed by the DCS6 SPI slave it
starts transmitting the generated response. The SPI master should
stream zero's (0x0000) on the SPISIMO pin until it receives the
complete
response from the slave. This method of streaming zero's is applicable
only when the command payload (i.e.both
application command payloads and link control command payloads)
generates a response. For
application command payloads that do not generate a response, the SPI
master need not stream zero's and can send the next command payload
immediately depending upon the SPI flow control mechanism used and its
indicated status. The zero (0x0000) data streaming used by the SPI
master
and slave should always happen at payload boundaries i.e. a zero
(0x0000)
data fill should never be done in the middle of a payload transfer
unless the payload data itself contains an element with zero value.<br>
<h6>Examples</h6>
<span style="font-family: monospace;">Consider
a payload of the form:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0xpqrs,0xtuvw<br>
</code></div>
<br style="font-family: monospace;">
<span style="font-family: monospace;">The
payload is specified in the
hexadecimal format with p,q,r,s and
t,u,v,w representing the nibbles (4 bits) in the 16-bit words. Since
the payload consists of 2 elements (2 16-bit elements) the Count field
value is 2.
With little endian format used for transmission the data on the SPISIMO
pin in element size units would look like:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x0002,0xpqrs,0xtuvw<br>
<br>
</code></div>
<span style="font-family: monospace;">If
this command generates a
response </span><code style="font-family: monospace;">0xwxyz
</code><span style="font-family: monospace;">where
w,x,y,z represent the nibbles (4 bits) in the 16-bit response then the
message is transmitted back on the SPISOMI pin in little endian format
like:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0x0001,0xwxyz<br>
<br>
</code></div>
<span style="font-family: monospace;">Applying
the zero fill between
the command and response the data on the
SPI data lines should be of the form:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>Data
on SPISIMO pin: </code><code>0x0002,0xpqrs,0xtuvw,</code><code>0x0000,..........,0x0000,0x0000,0x0000<br>
Data on SPISOMI pin: 0x00,.................................,0x0000,</code><code>0x0001,0xwxyz<br>
<br>
</code></div>
<span style="font-family: monospace;">Now
consider the same payload
above needs to be transmitted 75 times in
a
single session. Though transmitting the same payload multiple times in
a session does not make any practical sense, it is used here to
demonstrate a large payload transmission. The total
length of the payload in this case would be 150 elements (75*4 bytes or
150 16-bit elements).
With little endian format used for transmission the data on the SPI
data lines in element size units would look like:</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(0)
on SPISIMO pin: </code><code>0x0096,</code><code>0xpqrs,0xtuvw,</code><code>0xpqrs,0xtuvw,......</code><code></code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(0)
on SPISOMI pin:
0x0000,..................................</code><code></code><br>
</div>
<code></code></div>
<code style="font-family: monospace;"></code><br
 style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(1)
on SPISIMO pin:</code><code>
......,</code><code>0xpqrs,0xtuvw</code><code>,</code><code>0x0000,..............</code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(1)
on SPISOMI pin:
0x0000,...................................</code><code></code><br>
</div>
<code></code></div>
<code style="font-family: monospace;">
</code><br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(2)
on SPISIMO pin:</code><code>
.....,</code><code>0x</code><code>0000,......................,0x0000</code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data(2)
on SPISOMI pin:
.....,0x004B,</code><code>0xwxyz,</code><code>0xwxyz,</code><code>........,0xwxyz</code><br>
</div>
<code></code></div>
<code style="font-family: monospace;">
</code><br style="font-family: monospace;">
<code style="font-family: monospace;"></code><span
 style="font-family: monospace;">In
the case of command payloads that do not generate a
response the zero data fill is not required and the commands can be
sent back to back in the form:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISIMO pin: </code><code>0x0001,0xghij,</code><code>0x0001,0xghij</code><code></code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISOMI pin:
0x0000,.............,0x0000<br>
</code><code></code><br>
</div>
<code></code></div>
<span style="font-family: monospace;">where
g,h,i,j represent the
nibbles (4 bits) in the 16-bit command
payload that does not generate a response.</span><br
 style="font-family: monospace;">
<br style="font-family: monospace;">
<span style="font-family: monospace;">The
Ready SLC command sent over
the SPISIMO pin and the corresponding
Success SLS response sent over the SPISOMI pin in little endian format
would appear like:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISIMO pin: </code><code>0x8001,</code><code>0x0000,..........,0x0000</code><br>
</div>
<code></code></div>
<div style="margin-left: 40px; font-family: monospace;">
<div style="margin-left: 160px;"><code>Data
on SPISOMI pin:
0x0000,.................,0xF001</code><code><br>
<br>
</code></div>
<code></code></div>
<code style="font-family: monospace;"></code><span
 style="font-family: monospace;">
The examples above just represent the payload data and the complete SPI
transfer protocol with all signals is not shown here. This is
done deliberately to emphasize the SPI communication payload
construction and transmission. In addition to the little endian mode of
data transfer it is important to note here that within a byte the most
significant bit is shifted out on the SPI data line prior to the least
significant bit. For details on the SPI physical protocol
refer the DA8xx
SPI User Guide.<br>
<br>
</span>The DCS6 module does not
source any messages by itself, but only
responds to the commands sent by the microcontroller/master. The
SLC commands sent by the master result in the generation of SLS
messages and the alpha command payloads sent by the master invoke a
response message payload depending upon the constituent alpha commands.
<br>
<br>
The DCS6 SPI slave supports several modes
of SPI communication. These
modes differ in the number of pins used, the pin configurations and
phase and polarity of the clock signal as described below:<br>
<ul>
  <li>SPI 3 pin mode - This mode
uses the data signals SPISIMO, SPISOMI and clock signal SPICLK. The SPI
slave uses the SPISIMO and SPICLK pins for input and the SPISOMI pin is
used to drive the SPI slave output data. The SPISOMI pin output is not
gated by the master signals and hence the signal cannot be shared with
other SPI slave devices. Since this mode does not use any hardware
handshaking the SPI master needs to take additional care to not overrun
the SPI slave.<br>
  </li>
  <li>SPI 4 pin chip select mode -
This mode uses the slave chip select signal SPISCS in addition to the 3
signals used in SPI 3 pin mode. The SPI master must drive low the
SPISCS signal to select the SPI slave. The SPI slave configures the
SPISCS pin
as input and uses it to gate the output data on the SPISOMI pin i.e.
the SPI slave drives the SPISOMI pin only when it is selected for
communication otherwise the SPI slave tri-states the SPISOMI output. In
this mode the SPISOMI signal can be shared with other SPI slave
devices. Since this mode does not use any hardware handshaking the SPI
master needs to take additional care to not overrun the SPI slave.</li>
  <li>SPI 4 pin enable mode - This
mode uses the enable/ready signal SPIENA pin in addition to the 3
signals used in SPI 3 pin mode. The SPI slave configures the SPIENA pin
as output and drives it low when slave is ready to accept data. When
the SPI slave is busy and cannot accept new data the SPIENA pin can be
configured to either tri-state the output or drive it high. The SPISOMI
and SPIENA pin outputs are not gated by the master signals and hence
these signals cannot be shared with other SPI slave devices.</li>
  <li>SPI 5 pin mode - This mode
uses the slave chip select signal SPISCS and enable/ready signal SPIENA
in addition to the 3 signals used in SPI 3 pin mode. The SPI master
must drive low the SPISCS signal to select the SPI slave. The SPI slave
configures the SPISCS pin as input and SPIENA pin as output. The SPI
slave drives the SPIENA pin low when it is ready to accept new data and
drives it high or tri-states it depending upon the pin configuration
while it is busy. The SPISOMI and SPIENA pin outputs are gated by the
SPISCS signal and hence are driven only when the SPI slave is selected.
Thus these signals can be shared with other SPI slave devices.</li>
  <li>SPI 5 pin mode with software
ready - This mode is similar to the SPI 5 pin mode but differs in the
way the enable/ready signal is configured. In this mode the SPIENA pin
is configured in non-native mode and is controlled by DCS6 software.
The SPIENA pin is not driven on per word (1 element-size unit) basis,
but is driven based on the available free space in the DCS6 software
buffer thereby relieving the SPI master from checking the SPI slave
readiness for every word transfer. This flexibility though comes at a
cost and the extra cost is in terms of the enable/ready SPIENA signal
sharing. Since the SPIENA pin is controlled by the DCS6 software, it is
always driven high or low depending upon the buffer watermark levels
and is not gated by the SPISCS signal. Hence the SPIENA signal cannot
be shared with other SPI slave devices.</li>
</ul>
The DCS6 module provides choice of four SPI clock configurations with
different combinations of clock phase and polarity settings for each of
the above SPI modes. For more details on the SPI modes and settings
refer the <cite>DCS6
Parameters<a href="#References"><sup>[3]</sup></a></cite>
documentation.<br>
<br>
The DCS6 module can be configured to detect and
report certain error
conditions with the SPI communication. The mechanism to report the
error conditions can be configured with the DCS6 module API's that
allow initialization, assertion and de-assertion of the selected
mechanism. For more on this refer the <cite>DCS6
Parameters<a href="#References"><sup>[3]</sup></a></cite>
documentation.<br>
<br>
<hr style="width: 100%; height: 2px;">
<h3><a class="mozTocH3" name="mozTocId940449"></a><a id="ACM"
 name="Ascii_Communication_Mode"></a>Ascii
Communication
Mode</h3>
The DCS6 module supports communication over UART devices using ascii
mode of communication. The applications command and message data is
ascii-encoded and transmitted in the form of S-records.
The DCS6 module uses <cite>Motorola
standard
S-records<a href="#References"><sup>[4]</sup></a> </cite>for this
purpose and then some other S-records that
are defined and used by the DCS6 module.<br>
<h4><a class="mozTocH4" name="mozTocId790173"></a><a id="SR"
 name="S-Records"></a>S-Records</h4>
The DCS6 module uses a subset of the <cite>Motorola
standard S-records<a href="dcs6_tp.html#References"><sup>[4]</sup></a></cite>
namely the
S0, S1 and S9 S-records. Each S-record is terminated by a carriage
return ( '\r' or 0x0D) and followed by a line feed ('\n' or 0x0A)
character.<br>
<ul>
  <li>The S0 record is used to
indicate start of a payload session. The <em>data</em>
field of the S0 record is not used by the DCS6 module. Thus the S0
record is of the form:</li>
</ul>
<div style="margin-left: 200px;"><code>S0030000FC\r\n</code></div>
<ul>
  <li>The S1 record is used to
carry the payload. The <em>data </em>field
of the S1 record is
used to represent the
ascii-encoded payload data in little endian form i.e. the ascii-encoded
representation for least
significant byte precedes the ascii-encoded representation for most
significant byte in a 16-bit alpha word ascii-encoded representation.
The DCS6 module supports S1 records with
total length of up to 80 bytes, this includes the terminal carriage
return
and line feed characters. So though a small payload requires only a
single S1 record, a large payload may span across multiple S1 records.
In this case though the payload data is split across S1 records, an
alpha word
should never be split into two S1 records i.e. a S1 record <em>data</em>
field always encodes data in units of alpha word (16-bit word). Also
the <em>address </em>field
indicates the address in units of alpha words. Thus an application
command payload or the form <code>"0xpqrs,0xtuvw"</code>
would be represented into an S1 record like:</li>
  <br>
  <div style="margin-left: 160px;"><code>S1070000RSPQVWTU??\r\n</code></div>
  <br>
where <code>P,Q,R,S</code>
and <code>T,U,V,W </code>are
the ascii-encoded values for the binary data nibbles <code>p,q,r,s</code>
and <code>t,u,v,w</code>
respectively and <code>??</code>
is a placeholder for the checksum whose value depends upon the the
payload data.<br>
</ul>
<ul>
  <li>The S9 record is used to
indicate end (or stop) of a payload session.The S9 record is of the
form:</li>
</ul>
<div style="margin-left: 200px;"><code>S9030000FC\r\n<br>
</code></div>
<br>
S0 and S9 records are used to encapsulate the S1 records and serve as
the start
and stop S-records. Thus a single payload transfer session would appear
like:<br>
<br>
<div style="margin-left: 40px;">
<div style="margin-left: 160px;"><code>S0030000FC\r\n</code><br>
<code>S1070000RSPQVWTU??\r\n</code><br>
<code>S9030000FC\r\n</code><br>
</div>
<code></code></div>
<code>
</code>
<ul>
</ul>
In addition to the above standard S-records, DCS6 module defines a few
more S-records for the purpose of link control and status. These DCS6
specific S-records are described below.<br>
<ul>
  <li>SC record - The SC Records
or Control S-records address the underlying link mechanism. The Reset
SC record "<code>SC0380017B\r\n</code>"
is used by the microcontroller/master to reset the
physical link used by the DCS6 module and the Ready SC record "<code>SC0381017A\r\n</code>"
is used by the microcontroller/master to check if the DCS6
module is ready for communication. The response is Status S-record or
SS record "<code>SS03F0010B\r\n</code>"
indicating success or empty record "<code>\r\n</code>"
for any error.<br>
  </li>
</ul>
<div style="margin-left: 200px;"><code>Reset
SC record - </code><code>SC0380017B\r\n</code><br>
<code></code><code>Ready
SC record - </code><code>SC0381017A\r\n</code><code>
</code></div>
<ul>
  <li>SS record - The SS records
or Status S-records are sent by the DCS6 module in response to
the SC records sent by the microcontroller/master. The Success SS
record "<code>SS03F0010B\r\n</code>"
indicates that the operation requested by the SC record is
successful while the Error/Empty record
"<code>\r\n</code>"
indicates that the operation requested by the SC record has
met with some problems and cannot be completed.</li>
</ul>
<div style="margin-left: 200px;"><code>Success
SS record - </code><code>SS03F0010B\r\n</code><br>
<code>Error record - \r\n<br>
<br>
</code></div>
<h4><a class="mozTocH4" name="mozTocId690164"></a><a id="UARTC"
 name="UART_Communication"></a>UART
Communication</h4>
The DCS6 module supports ascii communication using the DA8xx UART0,
UART1 and UART2 devices. The UART communication uses 1 Start bit, 8
Data Bits and 1 Stop bit, with the data represented in ascii format.
The UART communication requires a payload (a
payload may have one or more application commands and messages or alpha
commands and messages) to be encoded in <a href="#S-Records">S-Record</a>
format. The microcontroller/master sends the command S-record S0-S1-S9
(Start-Data-Stop) sequence to the DCS6 UART slave device. The DCS6
module processes the command payload and responds using a message
S-record S0-S1-S9 sequence. In case the master command payload does not
generate a response, the DCS6 SPI slave uses an empty S1 record as
response. Thus the DCS6 module always generates and send a response
irrespective of the type of application command. This behavior of DCS6
ascii communication mode is different from the other binary
communication modes. The payload exchange between the
microcontroller/master and the DCS6 UART is one-to-one with respect to
the S-record S0-S1-S9 sequence i.e. a command S0-S1-S9 sequence results
in the generation of a response S0-S1-S9 sequence. The number of S1
records encapsulated in between the S0 and S9 records depends upon the
command/message length and there is no definite one-to-one relation
between the command and message S1 records.<br>
<br>
The response message from the DCS6 UART slave is always in the form of
an encapsulated alpha code even though the corresponding command may
not be encapsulated. The type of alpha code encapsulation used depends
upon the length of the message. This is done for compatibility with the
host tools and for historical reasons. Note that this encapsulation
uses an alpha command type for encapsulating the message, before it is
encoded in the <em>data</em> field of the S1 record and is different
from the S0 and S9 records that encapsulate the string of S1 records.
For more details on the alpha code encapsulation refer <cite>Performance
Audio Messaging Application Protocol Application Report<a
 href="dcs6_tp.html#References"><sup>[1]</sup></a></cite>.<br>
<br>
The microcontroller/master can also send link control commands or SC
records to reset the link or query the link status. The DCS6 UART slave
conveys the status using a link status message or SS record.<br>
<h6>Examples</h6>
<span style="font-family: monospace;">Consider
a payload of the form:</span><br style="font-family: monospace;">
<br style="font-family: monospace;">
<div style="margin-left: 200px; font-family: monospace;"><code>0xpqrs,0xtuvw<br>
</code></div>
<br style="font-family: monospace;">
<span style="font-family: monospace;">The
payload is specified in the
hexadecimal format with p,q,r,s and
t,u,v,w representing the nibbles (4 bits) in the 16-bit words. The
S0-S1-S9 command sequence for the payload would be of the form:<br>
<br>
</span>
<div style="margin-left: 200px;"><code>S0030000FC\r\n</code><br>
<code>S1070000RSPQVWTU??\r\n</code><br>
<code>S9030000FC\r\n<br>
<br>
</code></div>
<span style="font-family: monospace;">where
</span><code style="font-family: monospace;">P,Q,R,S</code><span
 style="font-family: monospace;">
and </span><code style="font-family: monospace;">T,U,V,W </code><span
 style="font-family: monospace;">are
the ascii-encoded values for the binary data nibbles
</span><code style="font-family: monospace;">p,q,r,s</code><span
 style="font-family: monospace;">
and </span><code style="font-family: monospace;">t,u,v,w</code><span
 style="font-family: monospace;">
respectively and </span><code style="font-family: monospace;">??</code><span
 style="font-family: monospace;">
is a placeholder for the checksum whose value depends upon the the
command payload data.</span><br>
<br>
<span style="font-family: monospace;">If
this command generates a
response </span><code style="font-family: monospace;">0xwxyz
</code><span style="font-family: monospace;">where
w,x,y,z represent the nibbles (4 bits) in the 16-bit response then the
S0-S1-S9 response sequence would be of the form:<br>
</span><span style="font-family: monospace;"><br>
</span>
<div style="margin-left: 200px;"><code>S0030000FC\r\n</code><br>
<code>S1050000YZWX??\r\n</code><br>
<code>S9030000FC\r\n<br>
<br>
</code></div>
<span style="font-family: monospace;"></span><span
 style="font-family: monospace;">
where </span><code style="font-family: monospace;">W,X,Y,Z</code><span
 style="font-family: monospace;">
</span><span style="font-family: monospace;">are
the ascii-encoded values for the binary data nibbles </span><code
 style="font-family: monospace;">w,x,y,z</code><span
 style="font-family: monospace;"></span><span
 style="font-family: monospace;"> and </span><code
 style="font-family: monospace;">??</code><span
 style="font-family: monospace;">
is a placeholder for the checksum whose value depends upon the the
message payload data.<br>
<br>
If the above command does not generate a response then the DCS6 UART
slave responds with:<br>
</span><span style="font-family: monospace;"><br>
</span>
<div style="margin-left: 200px;"><code>S0030000FC\r\n</code><br>
<code>S105000000C931\r\n</code><br>
<code>S9030000FC\r\n<br>
<br>
</code></div>
<span style="font-family: monospace;">where
the S1 record <em>data </em>field
contains empty response "0xC900". For more details on the empty
response refer the </span><cite style="font-family: monospace;">Performance
Audio Messaging Application Protocol Application Report<a
 href="dcs6_tp.html#References"><sup>[1]</sup></a></cite><span
 style="font-family: monospace;"><span
 style="text-decoration: underline;"></span></span><a
 href="dcs6_tp.html#References"><span style="font-family: monospace;"></span></a>.<br>
<br>
<span style="font-family: monospace;">Now
consider the same payload
above needs to be transmitted 75 times in
a
single session. Though transmitting the same payload multiple times in
a session does not make any practical sense, it is used here to
demonstrate a large payload transmission. The command S0-S1-S9 command
sequence would be of the form:<br>
<br>
</span>
<div style="margin-left: 200px;"><span style="font-family: monospace;">S0030000FC</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S1210000RSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQ??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S121000FVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTU??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S121001ERSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQ??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S121002DVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTU??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S121003CRSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQ??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S121004BVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTU??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S121005ARSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQ??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S1210069VWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTU??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S1210078RSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQ??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S1210087VWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTURSPQVWTU??</span><code>\r\n</code><br
 style="font-family: monospace;">
<span style="font-family: monospace;">S9030000FC</span><code>\r\n</code></div>
<span style="font-family: monospace;"><br>
Note that the command payload spans across multiple S1 records with
each S1 record <em>data</em> field encoding a max of 15 alpha words
(16-bit words). Also the <em>address</em> field indicates the address
in units of alpha words.<br>
<br>
</span><code style="font-family: monospace;"></code><span
 style="font-family: monospace;">The examples above just represent the
payload data and the complete UART
transfer protocol is not shown here. This is
done deliberately to emphasize the UART communication payload
construction and transmission. For details on the UART physical
protocol
refer the DA8xx
UART User Guide.<br>
<br>
The sample code below demonstrates the conversion between the alpha
codes and S-records.<br>
<br>
</span>
<div style="margin-left: 40px;">
<div style="margin-left: 160px;"><span style="font-family: monospace;"><code>#include
&lt;stdio.h&gt;</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>/* Limit the S1 record data
field to encode max 15 alpha words (16bit words) */</code></span><br>
<span style="font-family: monospace;"><code>#define
SREC_LIM&nbsp;&nbsp;&nbsp; 15</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>typedef unsigned char Uint8;</code></span><br>
<span style="font-family: monospace;"><code>typedef unsigned short
Uint16;</code></span><br>
<span style="font-family: monospace;"><code>typedef unsigned int Uint32;</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>/*</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* i8tox converts an
8-bit unsigned integer value to ascii representation.</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* Arguments:</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
s - 8-bit unsigned integer value</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
d - pointer to buffer for writing the ascii output</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*/</code></span><br>
<span style="font-family: monospace;"><code>void i8tox(</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8 s,</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8 *d)</code></span><br>
<span style="font-family: monospace;"><code>{</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
sp[2];</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32 i;</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
sp[0]=s&gt;&gt;4&amp;0xF;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
sp[1]=s&amp;0xF;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;2;++i){</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
if(sp[i]&lt;=0x9)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d[i]=sp[i]+'0';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
else if(sp[i]&gt;=0xa&amp;&amp;sp[i]&lt;=0xf)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d[i]=sp[i]-10+'A';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
else</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d[i]='0';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; }</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; return;</code></span><br>
<span style="font-family: monospace;"><code>}</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>/*</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* itox converts an
alpha command/message payload into a S1 record.</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* Arguments:</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
s - pointer to alpha command/message buffer</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
slen - length of the alpha command/message in alpha words (16-bit words)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
d - pointer to buffer for writing the S1 record</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* Return value:</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
length of the S1 record in bytes</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*/</code></span><br>
<span style="font-family: monospace;"><code>Uint32 itox(</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint16
*s,</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32
slen,</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8 *d)</code></span><br>
<span style="font-family: monospace;"><code>{</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
*s8=(Uint8*)s;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32
dlen=0;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
cnt;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint16
adr=0;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
cks;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32 i;</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
while(slen){</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
cnt=slen&gt;SREC_LIM?SREC_LIM:slen;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
slen-=cnt;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*d++='S';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*d++='1';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
i8tox((cnt&lt;&lt;1)+3,d);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d+=2;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
i8tox(adr&gt;&gt;8&amp;0xFF,d);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d+=2;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
i8tox(adr&amp;0xFF,d);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d+=2;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
cks=((cnt&lt;&lt;1)+3&amp;0xFF)+(adr&gt;&gt;8&amp;0xFF)+(adr&amp;0xFF);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;cnt&lt;&lt;1;++i){</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
i8tox(*s8,d);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d+=2;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
cks+=*s8;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
s8++;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
}</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
i8tox(~cks,d);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d+=2;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
adr+=cnt;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*d++='\r';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*d++='\n';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
dlen+=2+2+4+(cnt&lt;&lt;2)+2+2;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; }</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; return
dlen;</code></span><br>
<span style="font-family: monospace;"><code>}</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>/* x2toi converts a pair of
ascii-codes into 8-bit unsigned integer.</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* Arguments:</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
s - pointer to the ascii buffer</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* Return value:</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
8-bit unsigned integer value</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*/</code></span><br>
<span style="font-family: monospace;"><code>Uint8 x2toi(</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8 *s)</code></span><br>
<span style="font-family: monospace;"><code>{</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
d[2];</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32 i;</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;2;++i){</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
if(s[i]&gt;='0'&amp;&amp;s[i]&lt;='9')</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d[i]=s[i]-'0';</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
else if(s[i]&gt;='A'&amp;&amp;s[i]&lt;='F')</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d[i]=s[i]-'A'+10;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
else if(s[i]&gt;='a'&amp;&amp;s[i]&lt;='f')</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d[i]=s[i]-'a'+10;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
else</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
d[i]=0;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; }</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; return
d[0]*16+d[1];</code></span><br>
<span style="font-family: monospace;"><code>}</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>/*</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* xtoi converts a S1
record into alpha command/message payload</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* Arguments:</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
s - pointer to the S1 record</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
d - pointer to the buffer for writing the alpha command/message payload</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;* Return value:</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;
length of the alpha command/message payload in </code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
units of alpha word (16-bit word)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;*/</code></span><br>
<span style="font-family: monospace;"><code>Uint32 xtoi(</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8 *s,</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint16
*d)</code></span><br>
<span style="font-family: monospace;"><code>{</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
*d8=(Uint8*)d;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32
dlen=0;</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; s+=8;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
while(!(*(s+2)=='\r'&amp;&amp;*(s+3)=='\n')){</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*d8++=x2toi(s);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
s+=2;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
dlen++;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; }</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; return
dlen&gt;&gt;1;</code></span><br>
<span style="font-family: monospace;"><code>}</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>int main()</code></span><br>
<span style="font-family: monospace;"><code>{</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint16
ac[2]={0xc244,0x0400};</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
srec[80];</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint16
ac1[2];</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint16
acl[20]={0xc244,0x0400,0xc244,0x0400,0xc244,0x0400,0xc244,0x0400,</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
0xc244,0x0400,0xc244,0x0400,0xc244,0x0400,0xc244,0x0400,</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
0xc244,0x0400,0xc244,0x0400};</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint8
srecl[160];</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint16
acl1[20];</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32
slen;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32
alen;</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; Uint32 i;</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; /*
Convert alpha command to S-records */</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Converting alpha command to S-record\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Input:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;2;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("0x%04x%c",ac[i],i==1?'\n':',');</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Output:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
slen=itox(ac,2,srec);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("S0030000FC\r\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;slen;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("%c",srec[i]);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("S9030000FC\r\n");</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; /*
Convert S1 record to alpha command/message */</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("\nConverting S1 record to alpha command\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Input:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;slen;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("%c",srec[i]);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Output:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
alen=xtoi(srec,ac1);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;alen;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("0x%04x%c",ac1[i],i==alen-1?'\n':',');</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; /*
Convert long alpha command to S-records */</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("\nConverting alpha command to S-record\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Input:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;20;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("0x%04x%c",acl[i],i==19?'\n':',');</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Output:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
slen=itox(acl,20,srecl);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("S0030000FC\r\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;slen;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("%c",srecl[i]);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("S9030000FC\r\n");</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; /*
Convert S1 record to long alpha command/message */</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("\nConverting S1 record to alpha command\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Input:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;slen;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("%c",srecl[i]);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
printf("Output:\n");</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
alen=xtoi(srecl,acl1);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
alen+=xtoi(srecl+(alen&lt;&lt;2)+12,acl1+alen);</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;
for(i=0;i&lt;alen;++i)</code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
printf("0x%04x%c",acl1[i],i==alen-1?'\n':',');</code></span><br>
<span style="font-family: monospace;"><code></code></span><br>
<span style="font-family: monospace;"><code>&nbsp;&nbsp;&nbsp; return 0;</code></span><br>
<span style="font-family: monospace;"><code>}</code></span><br>
</div>
<span style="font-family: monospace;"></span></div>
<span style="font-family: monospace;"></span><br>
The DCS6 module does not
source any messages by itself, but only
responds to the commands sent by the microcontroller/master. The
SC records sent by the master result in the generation of SS records
and the command S0-S1-S9 sequence sent by the master results in the
generation of response S0-S1-S9 sequence.<br>
<br>
The DCS6 UART communication uses the data pins UART_TXD and UART_RXD,
the handshake signals UART_CTS and UART_RTS are not used. The flow
control is performed by transmitting the non-printable characters <em>Xon
(0x11)</em> and <em>Xoff (0x13)</em> on the data lines. When the DCS6
UART slave is busy processing the received data and cannot accept new
data from the microcontroller/master it sends a <em>Xoff </em>character.
Once the data is processed and there is enough room to accept new data
the DCS6 UART slave transmits a <em>Xon</em> character indicating its
readiness to resume communication with the microcontroller/master. The
microcontroller/master can similarly use the <em>Xon/Xoff</em>
characters to control the slave transmit data rate. The flow control
mechanism depends on the buffer availability and hence can be exercised
at any time during the payload transfer.<br>
<br>
The DCS6 UART communication data rate and oversampling rate can be
configured using the DCS6 parameters. For more on this refer the <cite>DCS6
Parameters<a href="dcs6_tp.html#References"><sup>[3]</sup></a></cite>
documentation.<br>
<br>
The DCS6 module can be configured to detect and
report certain error
conditions with the UART communication. The mechanism to report the
error conditions can be configured with the DCS6 module API's that
allow initialization, assertion and de-assertion of the selected
mechanism. For more on this refer the <cite>DCS6
Parameters<a href="dcs6_tp.html#References"><sup>[3]</sup></a></cite>
documentation.<br>
<br>
<hr style="width: 100%; height: 2px;">
<h3><a class="mozTocH3" name="mozTocId24536"></a><a id="Ref"
 name="References"></a>References</h3>
<ol>
  <li>Baudendistel, Kurt, and
Longley, Lester, "Performance Audio Messaging Application Protocol",
Momentum Data Systems, TI Performance Audio.</li>
  <li>Baudendistel, Kurt,
"Performance Audio Messaging Transport Protocol", Momentum Data
Systems, TI Performance Audio.</li>
  <li><a href="dcs6.html">"DCS6 Parameters", TI Performance
Audio.</a></li>
  <li>Motorola S-records, <a
 href="http://www.amelek.gda.pl/avr/uisp/srecord.htm">http://www.amelek.gda.pl/avr/uisp/srecord.htm</a></li>
</ol>
</body>
</html>
